(function () {
  const reShopify = /https:\/\/cdn\.shopify\.com/gi;
  const re =
    /ShopifyAnalytics.lib.track\("Viewed Product",{"currency":"(.*?)",.*"productId":(\d+?),.*"price":"(.*?)"/gi;

  window.addEventListener("message", function (event) {
    const { code } = event.data || {};
    // console.log("INJECT: ", event.data);

    switch (code) {
      case "INJECT_FB_MOCK_ORDER_REQ": {
        if (!window.fbq) {
          // no fb pixel
          window.postMessage({
            code: "INJECT_FB_MOCK_ORDER_RESP",
            ret: 1
          });
          return;
        }

        const is_shopify = reShopify.test(document.documentElement.innerHTML);
        if (!is_shopify) {
          // no shopify store
          window.postMessage({
            code: "INJECT_FB_MOCK_ORDER_RESP",
            ret: 2
          });
          return;
        }

        const m = re.exec(document.documentElement.innerHTML);
        if (!m || m.length < 4) {
          // no product info page
          window.postMessage({
            code: "INJECT_FB_MOCK_ORDER_RESP",
            ret: 3
          });
          return;
        }

        const currency = m[1],
          productId = m[2],
          price = m[3];

        // console.log(currency, productId, price);

        window.fbq("track", "AddToCart", {
          content_type: "product_group",
          content_ids: [productId],
          currency: currency,
          value: price,
          num_items: 1
        });

        setTimeout(() => {
          window.fbq("track", "InitiateCheckout", {
            content_type: "product_group",
            content_ids: [productId],
            currency: currency,
            value: price,
            num_items: 1
          });
        }, 100);

        setTimeout(() => {
          window.fbq("track", "Purchase", {
            content_ids: [productId],
            content_type: "product_group",
            currency: currency,
            value: price,
            num_items: 1
          });
        }, 200);

        setTimeout(() => {
          window.postMessage({
            code: "INJECT_FB_MOCK_ORDER_RESP",
            ret: 9
          });
        }, 300);
      }
    }
  });
})();
